/*
 *
 * @(#)MatchedButton.java 0.2 99/09/29
 *
 * Copyright (c) 1999 Ginger Booth.  All Rights Reserved.
 *
 * @history: original
 * @author Ginger Booth
 * @version 0.2, September1999
 *
 * 'Tis reported that under Linux, Buttons default not to Netscape
 * grey as they do under Windows, but to whatever the last foreground
 * color was on the container they're in. Which generally looks rather
 * awful. So MatchedButton is simply Button, with static members foreground
 * and background, to allow conveniently setting 'em all to match colors.
 */
package courseware.jfcdep;
import java.awt.*;
import courseware.util.*;

public class MatchedButton extends Button {
  static public Color background = new Color(204, 204, 204);
  static public Color foreground = new Color(0,0,0);

  public MatchedButton() {
    this("");
  }
  public MatchedButton(String label) {
    super(label);
    setForeground(foreground);
    setBackground(background);
  }

  public void updateColor() {
   super.setForeground(foreground);
   super.setBackground(background);
  }

  public void setForeground(Color c) {foreground=c; super.setForeground(c);}
  public void setBackground(Color c) {background=c; super.setBackground(c);}

}
