package courseware.jfcdep;

import javax.swing.*;
import java.awt.*;
import javax.swing.plaf.basic.BasicGraphicsUtils;

/**
 * Title:        Courseware
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Yale Inst. Biospheric Studies
 * @author Ginger Booth
 * @version 1.0
 */

public class ClearLabel extends JLabel {

  public ClearLabel(String s) {
    super(s);
    this.setHorizontalAlignment(Label.RIGHT);
this.setDoubleBuffered(true);
  }
  public ClearLabel() {
    super(" ");
    // setOpaque(false);
    this.setHorizontalAlignment(Label.RIGHT);
this.setDoubleBuffered(true);
  }

  /** super gives bad answer...*/
  public Dimension getPreferredSize() {
    Dimension d = super.getPreferredSize();
    if (getGraphics() == null)
      return d;
    FontMetrics fm = getGraphics().getFontMetrics();
    d.width = fm.stringWidth(getText() + 2);
    return d;
  }

  public void paint(Graphics g) {
    g.setPaintMode();
    setForeground(CWGlobals.foreground);
    g.setFont(CWGlobals.theFont);
    g.setColor(CWGlobals.foreground);
    FontMetrics fm = g.getFontMetrics();
    int ht = fm.getHeight();
    int hl = getSize().height;
    int yorig = hl - ((hl - ht) / 2) - fm.getDescent();
    g.drawString(getText(), 0, yorig);
  }
}