/*
 *
 * @(#)MatchedButton.java 0.2 99/09/29
 *
 * Copyright (c) 1999 Ginger Booth.  All Rights Reserved.
 *
 * @history: original
 * @author Ginger Booth
 * @version 0.2, September1999
 *
 * 'Tis reported that under Linux, Buttons default not to Netscape
 * grey as they do under Windows, but to whatever the last foreground
 * color was on the container they're in. Which generally looks rather
 * awful. So MatchedButton is simply Button, with static members foreground
 * and background, to allow conveniently setting 'em all to match colors.
 *
 * version 3, November2000
 * Tried extending Swing JButton, but looked horrible (need code changes
 * to and forcible recompile (add set/getLabel methods)) and didn't work
 * without more screwing around--not accomplishing what I wanted at all.
 * So let's try skinning awt.Button instead.
 */
package courseware.jfcdep;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import courseware.util.*;
import courseware.jfcdep.*;



public class MatchedButton extends JButton {
  static public Color background = new Color(204, 204, 204);
  static public Color foreground = new Color(0,0,0);

  public MatchedButton() {
    this("");
  }
  public MatchedButton(String label) {
    super(label);
    super.setUI(new SkinnedButtonUI());
    setForeground(foreground);
    setBackground(background);
  }

  public void updateColor() {
   super.setForeground(foreground);
   super.setBackground(background);
  }
/*
  public Dimension getPreferredSize() {
    Dimension d = super.getPreferredSize();
    d.width += spacing;
    d.height += spacing; // it's tall enuf
    return d;
  }
*/

  public void setForeground(Color c) {foreground=c; super.setForeground(c);}
  public void setBackground(Color c) {background=c; super.setBackground(c);}

  /*
  // paintComponent if want Swing border...
  public void paint(Graphics g) {
    Insets insets = getBorder().getBorderInsets(this);
    Dimension d = getSize();
    d.width  -= insets.left + insets.right;
    d.height -= insets.top + insets.bottom;
    g.setColor(Color.red);
    g.draw3DRect(insets.left, insets.top, d.width, d.height, true);
    g.setColor(Color.green);
    g.drawString(getText(), insets.right+insetText, d.height-insetText);
System.err.println("paint got d=" + d + ", string=" + getText());
  }
  */

}
