/*
 * 
 * @(#)FnTrace.java 0.2 98/07/13
 *
 * Copyright (c) 1998 Ginger Booth.  All Rights Reserved.
 * 
 * @author Ginger Booth
 * @version 0.2, July 1998
 */

package courseware.plot;
import java.awt.Color;

/** A FnTrace is a DataTrace which holds the function and suggested number of
 *  points to regenerate FnOfX and GenerableFn functions as plot traces.
 */
public class FnTrace extends DataTrace {
  private PlottableFn function;
  private int steps;

  /** nsteps is used to allocate, and to store how many points are
   *  desired when the function is regenerated. */
  public FnTrace(PlottableFn fn, Color c, int nSteps) {
      super(nSteps);
      setColor(c);
      function = fn;
      steps = nSteps;
  }
  public FnTrace() { super(); }

  public PlottableFn getFn() { return function; }
  public void setFn(PlottableFn func) { function = func; }
  public int getSteps() { return steps;}
  public void setSteps(int n) { steps=n;}
}
