/*
 *
 * @(#)NewRowMarker.java 0.3 99/02/01
 *
 * Copyright (c) 1999 Ginger Booth.  All Rights Reserved.
 *
 * @history: 990201, original, Kelly can't deal with Parameters popup menus
 * that are too wide. First problem report from CourseWare use in a course.
 * @author Ginger Booth
 * @version 0.3, 99/02/01
 *
 * A NewRowMarker is added to the components() Vector of "components for one
 * line of popup to set this parameter." This allows one Vector of "components",
 * but with markers showing the need for a newline. The "new row" generally
 * needs to be indented, since there can be a bunch of "one line" parameters on
 * a single menu. Since TableLayout takes care of sizing up fields to line up
 * vertically, the only indentation measure needed is columns in. Like, 0 means
 * flush left, 1 means start in 2nd column on popup....
 */
package courseware.util;

public class NewRowMarker {
  public int startColumn = 0;

  public NewRowMarker(int startInColumn) {
    startColumn = startInColumn;
  }
  public NewRowMarker() {
    startColumn = 0;
  }
}
