package courseware.util;

/**
 * Title:        Courseware Demographics Module
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Yale Inst. Biospheric Studies
 * @author Ginger Booth
 * @version 1.0
 * Was aligning text in the Pyramid class.... Just a utility class to
 * center/right/left text in a box. Limited by FontMetric's answers.
 */

import java.awt.*;

public class TextAlign {
  private Graphics graphics;
  private int margin; // don't want left and right on edge of box
  public static final int LEFT   = 0;
  public static final int RIGHT  = 1;
  public static final int CENTER = 2;

  public TextAlign(Graphics g, int margin) {
    graphics = g;
    this.margin = margin;
  }
  public void drawString(String string, int alignCode, int boxX0, int boxY0, int boxWidth, int boxHeight) {
    FontMetrics fm = graphics.getFontMetrics();
    int width = fm.stringWidth(string);
    int height = fm.getHeight() - fm.getDescent();
    int sx = margin;
    int sy = boxY0 + (boxHeight/2) + (height/2);
    if (alignCode == CENTER)
      sx = boxX0 + (boxWidth/2) - (width/2);
    else if (alignCode == RIGHT)
      sx = boxX0 + boxWidth - margin - width;
    graphics.drawString(string, sx, sy);
  }
}