//Title:        Gecko
//Version:
//Copyright:    Copyright (c) 1999, All rights reserved
//Author:       Ginger Booth, gingerbooth@cyber-wizard.com, ginger@gbooth.com
//Company:      Yale IBS/CCE
//Description:  Individual-Based Ecology Simulator
/**
 * 990330, vfb, original Java
 * Translated from the Swarm Objective-C Gecko source, version 0.51
 * With structural changes. Was Res.m
 */
/** A list of resources, with behaviors for convenience.
 *  MUST set Globals.numResources before creating these lists...So, let
 *  the agents handle making them, and use inquire/sets only....
 */

package gecko;

import courseware.util.*;
import courseware.plot.*;
import courseware.jfcdep.*;

public class ResourceList {
  public double[] list;

  public ResourceList() {
    list = new double[Globals.getResources().getNumResources()];
  }
  public Object clone() {
    ResourceList answer = new ResourceList();
    answer.add(this);
    return answer;
  }
  public void zero() {for (int i=0; i < list.length; i++)  list[i] = 0; }

  public void add(ResourceList other) {
    for (int i=0; i < list.length; i++)
      list[i] += other.list[i];
  }
  public void addPercent(double percent) {
    for (int i=0; i < list.length; i++)
      list[i] += percent * list[i];
  }

  public void subtract(ResourceList other) {
    for (int i=0; i < list.length; i++)
      list[i] -= other.list[i];
  }
  public void multiply(double factor) {
    for (int i=0; i < list.length; i++)
      list[i] *= factor;
  }

  public void setFrom(ResourceList other) {
    for (int i=0; i < list.length; i++)
      list[i] = other.list[i];
  }
  public String toString() {
    if (list == null) return "null";
    String ans = "ResourceList[";
    for (int i=0; i<list.length-1; i++)
      ans += TruncVal.truncVal(list[i]) + ",";
    if (list.length > 0)
      ans += TruncVal.truncVal(list[list.length-1]);
    ans += "]";
    return ans;
  }
}
