//Title:        Gecko
//Version:
//Copyright:    Copyright (c) 1999, All rights reserved
//Author:       Ginger Booth, gingerbooth@cyber-wizard.com, ginger@gbooth.com
//Company:      Yale IBS/CCE
//Description:  Individual-Based Ecology Simulator
/** Feeds through biomassFed tallies to a plot/file trace.
 *  BiomassFed is something Site's give--how much a site fed
 *  out to agents.
 */

package gecko.statglue;

import stats.*;
import gecko.*;

public class BiomassFedBroker extends StatSourceBroker {
  private double scale;

  public BiomassFedBroker(Site s, int resourceId) {
    statsource = (StatSource) s;
    scale      = Globals.getResources().getBioScale(resourceId);
  }
  public double getValue() {
    return ((Site) statsource).getBiomassFed();
  }
  public double getWeight() { return scale; };
}
