//Title:        Gecko
//Version:
//Copyright:    Copyright (c) 1999, All rights reserved
//Author:       Ginger Booth, gingerbooth@cyber-wizard.com, ginger@gbooth.com
//Company:      Yale IBS/CCE
//Description:  Individual-Based Ecology Simulator
/**
 * 990930, vfb, original Java
 * This is the default stage stat implementation for Critter--just newborn,
 * juvenile, and adult. If called with a non-Critter, insists on stage 0,
 * named "Newborn". Which is fine if all you want is full-pop mortality and
 * fertility.
 */

package gecko.statglue;
import gecko.zoo.*;
import gecko.*;

public class DefaultStageObserver implements StageObserver {
  private String[] stageLabels = { "Newborn", "Juvenile", "Adult" };
  private int stageCount = stageLabels.length;
  /** Implement StageObservable. */
  public int getNumStages() {return stageCount;}
  public int getStage(StageObservable agent) {
    if (!(agent instanceof Critter)) {
      return 0; // no stages for non-Critters
    } else {
      Critter critter = (Critter) agent;
      if ((Globals.getCurrentTime() - critter.getBirthday()) <= Globals.getStatCycle())
        return 0;
      else if ( (critter.getFirstBornOn() > 0) || (critter.wantsToReproduce()) )
        return 2;
      else
        return 1;
    }
  }
  public String getStageName(int i) {
    return stageLabels[i];
  }
}

