//Title:        Gecko
//Version:
//Copyright:    Copyright (c) 1999, All rights reserved
//Author:       Ginger Booth, gingerbooth@cyber-wizard.com, ginger@gbooth.com
//Company:      Yale IBS/CCE
//Description:  Individual-Based Ecology Simulator

/** Glue one bucket of StageStatBuckets onto plot/file output. */

package gecko.statglue;
import stats.*;

public class StageBucketBroker extends StatSourceBroker {
  private int stage;
  private int stat;

  public StageBucketBroker(StageStatBuckets source, int stage, int stat) {
    statsource = (StatSource) source;
    this.stage = stage;
    this.stat  = stat;
    normalizer = 1.0;
  }
  public StageBucketBroker(StageBucketBroker toCopy) {
    statsource = toCopy.statsource;
    stage      = toCopy.stage;
    stat       = toCopy.stat;
    normalizer = toCopy.normalizer;
    weighted   = toCopy.weighted;
  }
  public double getValue() {
    return ((StageStatBuckets) statsource).getStat(stage, stat);
  }
  /** need to weight by members + deaths, or newborn mortality is artificially 0. */
  public double getWeight() {
    if (weighted) {
      StageStatBuckets buckets = (StageStatBuckets) statsource;
      return buckets.getStat(stage, StageStatBuckets.MEMBERS) +
             buckets.getStat(stage, StageStatBuckets.DEATHS);
    } else
      return 1.0;
  }
}
