//Title:        Gecko Woods
//Version:
//Copyright:    Copyright (c) 1999, All rights reserved
//Author:       Ginger Booth, gingerbooth@cyber-wizard.com, ginger@gbooth.com
//Company:      Yale IBS/CCE
//Description:  "mini-Sortie"
/**
 * 991130, vfb, original Java
 * A function which can be added to Reaper. A single Reapable does whatever
 * by-timestep considerations needed (step), plus applies those conclusions
 * to a given agent (reap(tree)). For instance, a hurricane Reapable would
 * decide whether/how severe a hurricane on step, and if there is a hurricane,
 * kill trees accordingly on subsequent reap(Tree) calls.
 *
 * We're using the term "reapable" here in the Javaesque sense, not English.
 * (In English, the reapable would be the Tree, not that able to reap it....)
 */


package gecko.woods;

public interface Reapable {
  public void step();
  public void reap(ReapableTree tree);
}
