//Title:        Gecko Woods
//Version:
//Copyright:    Copyright (c) 1999, All rights reserved
//Author:       Ginger Booth, gingerbooth@cyber-wizard.com, ginger@gbooth.com
//Company:      Yale IBS/CCE
//Description:  "mini-Sortie"
/**
 * 991130, vfb, original Java
 * The Reaper is a collection of Reapable functions, each of which has
 * step (once per timestep) plus reap(Tree) (once per agent.) The Reaper
 * is added to Simulator as a MiscSteppable, from the param file, if
 * any Reaper is active for the Woods run. (Reaper is optional.)
 */
package gecko.woods;
import gecko.*;
import java.util.Vector;

public class Reaper implements Steppable {
  private Vector reapers; // of Reapable

  public Reaper() {
    reapers = new Vector(1,1);
  }
  public void addReaper(Reapable deathsource) {
  reapers.addElement(deathsource);}

  public void clear() {
  reapers = new Vector(1,1);}

  public void step() {
    // 1. Step all the sub-reapers (Reapable) to do their init thing
    for (int i=0; i<reapers.size(); i++) {
      ((Reapable)reapers.elementAt(i)).step();
    }

    // 2. Traverse the world, calling reap(Tree) for each reaper, each Tree.
    Quad treeroot = Globals.getPlantRoot();
    Quad qtree;
    Quad next;

    qtree = treeroot.pickWin(treeroot, treeroot, false);
    while (qtree != null) {
      // get next before giving this one a chance to die....
      next = qtree.pickWin(treeroot, treeroot, false);
      if (qtree instanceof Tree) {
        for (int j=0; j<reapers.size(); j++) {
          ((Reapable)reapers.elementAt(j)).reap((Tree)qtree);
        }
      }
      else if (qtree instanceof Tree3) {
        for (int j=0; j<reapers.size(); j++) {
          ((Reapable)reapers.elementAt(j)).reap((Tree3)qtree);
        }
      }
      qtree = next;
    }
  }
}
