
/*
 *
 * @(#)ZParabola.java 000908
 *
 * Copyright (c) 2000 Ginger Booth.  All Rights Reserved.
 * Find a parabola like the z-formula
 */

package gecko.woods;

import courseware.plot.*;
public class ZParabola extends FnParam {
  String defName = "Z = coeff * sqrt(dbh)";

  public ZParabola() {
    super();
    name = defName;
    setArgLabel(0, "Function");
    setArgLabel(1, "dbh0");
    setArgLabel(2, "ht0");
    setArgLabel(3, "dbhN");
    setArgLabel(4, "htN");
  }

  public double fOfX(double x, double stepx) {
    double dbh0 = numberValue[0];
    double ht0  = numberValue[1];
    double dbhN = numberValue[2];
    double htN  = numberValue[3];
    double coeff = (htN - ht0) / Math.sqrt(dbhN - dbh0);
    return ht0 + coeff * Math.sqrt(x - dbh0);
  }

}