
//Title:        Indeco Steel Simulator
//Version:      
//Copyright:    Copyright (c) 1999
//Author:       Joseph Guse & Ginger Booth
//Company:      Yale FES/CCE
//Description:  Individual-based economic simulator
//of the steel industry, ore->consumer,
//with transportation.

/** A free-floating Plotter in a Frame. Treat as Plotter or talk to
 *  its frame. Want them to behave as fixed pair.
 */

/** Adopted from Indeco for Gecko-in-CourseWare, 990708, vfb. */

package stats;


import java.awt.event.*;
import java.awt.*;
import courseware.plot.*;

/* for debug only */
import gecko.Globals;

public class PlotFrame extends Frame implements StatDumper {
  public Plotter plotter;

  public PlotFrame(String title) {
    super();
    plotter = new Plotter();
    setTitle(title);
    // changed to set background before adding plots, use grid layout
    // in attempt to fix blue weirdness on Linux.
    setBackground(plotter.getBackground());
    setLayout(new GridLayout(1,1));
    add(plotter);
    addWindowListener(new WindowAdapter(){
      public void windowClosing(WindowEvent e){
        myfinalize();
      }
    });
  }

  public void step() {
    if (!isVisible()) {
      // was setVisible(), but Linux came out with ugly blue bits
      pack();
      show();
      // This cures plotflashing on Netscape. The problem seems to be in
      // moving on to the next plotframe before this one's frame had a chance
      // to draw around the actual plot. A value of 50 milliseconds is enough
      // for my 233MMX Pentium. 250 should be enough for anything...? For 4
      // plots, this is 1 second of the runtime, to assure plots don't flash.
      // But Bacsim plots still flashed.... Maybe pack/show will stop that.
      try {
        Thread.currentThread().sleep(250);
      } catch (InterruptedException e) {
        System.err.println("PlotFrame.step, sleep interrupted: " + e);
      }
    }
    synchronized (plotter) {
      plotter.step();
      plotter.update();
    }
  }

  public void clear() {
    myfinalize();
  }
  public void reset() {plotter.reset();}

  public void myfinalize() {
    setVisible(false);
    plotter.finalize();
  }
  public void finalize() {
    myfinalize();
  }
  public int addTrace(SumTrace readyTrace) {return plotter.addTrace(readyTrace);}
  public void removeTrace(SumTrace readyTrace) {plotter.removeTrace(readyTrace);}

  public void update() {
    plotter.update();
  }

  public String toString() {
    return "PlotFrame" + gecko.Globals.pointerString(this) + "[title=" + getTitle() + "]";
  }
}

